/*
 * YDefaultVisualContainer.java
 *
 * Created on 17. April 2000, 22:49
 */
 
package YARB.Main;
import YARB.Interfaces.*;
import java.util.ArrayList;
import javax.swing.*;

/** 
 * The default container for visualization configuration
 * @author  Thomas
 * @version 
 */
public class YDefaultVisualContainer 
extends Object 
implements IVisualContainer
{

  protected ArrayList   m_Filter;
  protected IFileSource m_File;
  protected IDataViewer m_Viewer;
  protected String      m_strFile;
  
  /** Creates new YDefaultVisualContainer */
  public YDefaultVisualContainer() 
  {
    m_Filter=new ArrayList();
  }
  
  public void setFileSource(IFileSource FS) 
  {
    m_File=FS;
  }
  
  public void setDataView(IDataViewer DV) 
  {
    m_Viewer=DV;
  }
  
  public int numbOfDataFilter() 
  {
    return m_Filter.size();
  }
  
  public void setDataFilter(int nPos,IDataFilter DF) 
  {
    m_Filter.add(nPos,DF);
  }
  
  public void addDataFilter(IDataFilter DF) 
  {
    m_Filter.add(DF);
  }

  public void deleteDataFilter(int nPos) 
  {
    m_Filter.remove(nPos);
  }
  
  public boolean SaveConfiguration() 
  {
    return true;
  }
  
  public boolean LoadConfiguration() 
  {
    return true;
  }
  
  public boolean IsConfigurable() 
  {
    return true;
  }
  
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
    String str=JOptionPane.showInputDialog( ParentFrame,
                                            "Please choose a name:", "YARB Configuration properties",
                                             JOptionPane.QUESTION_MESSAGE);
    if(str!=null){
      setName(str);
    };
    return true;
  }

  public boolean DoVisualization(JFrame ParentFrame) 
  {
    if (m_File==null)
    {
      return false;
    };
    
    if(m_Viewer==null)
    {
      return false;
    };
    
    if(m_Filter.size() > 0)
    {
      int i=m_Filter.size()-1;

      m_Viewer.setDataSource((IDataFilter)m_Filter.get(i));
      
      while(i>0)
      {
        ((IDataFilter)m_Filter.get(i)).setPreviousProvider((IDataFilter)m_Filter.get(i-1));
        i--;
      };
      
      ((IDataFilter)m_Filter.get(0)).setPreviousProvider(m_File);    
    }
    else
    {
      m_Viewer.setDataSource(m_File);
    };
    
    m_Viewer.DoVisualize(ParentFrame);
 
    return true;
  }
  public void setFile(String strFile)
  {
    m_strFile=strFile;
  }
  
  
  /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }

  public IFileSource getFileSource() {
    return m_File;
  }
  public IDataViewer getDataView() {
    return m_Viewer;
  }
  public IDataFilter getDataFilter(int nPos) {
    return (IDataFilter) m_Filter.get(nPos);
  }
 
}
